/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated 
 * by the @authors tag. All rights reserved. 
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors. 
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author Mark Little (mark.little@jboss.com)
 */

import com.arjuna.orbportability.OA;
import com.arjuna.orbportability.RootOA;
import com.arjuna.orbportability.ORB;

import com.arjuna.ats.internal.jts.ORBManager;

import com.arjuna.ats.jta.TransactionManager;

import javax.transaction.*;

public class Test
{
    public static void main (String[] args) throws Exception
    {
	System.setProperty("com.arjuna.ats.jta.recovery.XAResourceRecovery1", "ExampleXAResourceRecovery");
	System.setProperty("com.arjuna.ats.jta.xaRecoveryNode", "*");

	ORB myORB = null;
	RootOA myOA = null;

	String xid1 = null;
	String xid2 = null;
	boolean recovery = false;
	
	for (int i = 0; i < args.length; i++)
	{
	    if (args[i].equals("-recover"))
		recovery = true;

	    if (args[i].equals("-xid1"))
		xid1 = args[i+1];
	    
	    if (args[i].equals("-xid2"))
		xid2 = args[i+1];
	}
	
	ExampleXAResource1.xid = xid1;
	ExampleXAResource2.xid = xid2;
	
	try
	{
	    myORB = ORB.getInstance("test");
	    myOA = OA.getRootOA(myORB);
	    
	    myORB.initORB(args, null);
	    myOA.initOA();

	    ORBManager.setORB(myORB);
	    ORBManager.setPOA(myOA);
	}
	catch (Exception e)
	{
	    System.err.println("Initialisation failed: "+e);

	    System.exit(0);
	}

	com.arjuna.ats.internal.arjuna.recovery.RecoveryManagerImple rm = new com.arjuna.ats.internal.arjuna.recovery.RecoveryManagerImple(true);

	if (!recovery)
	{
	    UserTransaction ut = com.arjuna.ats.jta.UserTransaction.userTransaction();

	    ut.begin();

	    Transaction txImple = TransactionManager.transactionManager().getTransaction();

	    txImple.enlistResource(new ExampleXAResource1());
	    txImple.enlistResource(new ExampleXAResource2());

	    ut.commit();
	}

        System.out.println("DONE");

	for (;;);
    }
}
